/*	keys.cpp
 *
 *	ITfKeyEventSink	implementation
 *
 *
 *	lȂ΂ȂȂ̂́A
 *		(1) L[Xg[N IME ɓn̂́A̎dȂ̂H
 *		(2)  IME ̏ɈړȂ΂ȂȂ̂H
 *	2_ł낤B(1) 𑁊KvB܂
 *	Ă݂AȂB
 */
#include "globals.h"
#include "skimic.h"
#include "editsess.h"
#include "skkimmgr.h"
#include "IME\ImeConfig.h"

/*	_InitKeystrokeSink
 *
 *	Advise a keystroke sink.
 */
BOOL
CSkkImeTextService::_InitKeystrokeSink ()
{
    ITfKeystrokeMgr*	pKeystrokeMgr ;
    HRESULT				hr ;

	if (m_pThreadMgr == NULL)
		return	FALSE ;
    if (m_pThreadMgr->QueryInterface(IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
        return	FALSE ;

    hr = pKeystrokeMgr->AdviseKeyEventSink(m_tfClientId, (ITfKeyEventSink *)this, TRUE);
	
    pKeystrokeMgr->Release () ;

    return	(hr == S_OK) ;
}


/*	_UninitKeystrokeSink
 *
 *	Unadvise a keystroke sink.  Assumes we have advised one already.
 */
void
CSkkImeTextService::_UninitKeystrokeSink ()
{
    ITfKeystrokeMgr *pKeystrokeMgr;

	if (m_pThreadMgr == NULL)
		return ;

    if (m_pThreadMgr->QueryInterface(IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
        return;

    pKeystrokeMgr->UnadviseKeyEventSink (m_tfClientId) ;
    pKeystrokeMgr->Release () ;
}

/*	Hot Key o^B
 *
 *	o^ꂽ Hot Key ꂽǂ OnPreservedKey 
 *	`FbNłB
 */
BOOL
CSkkImeTextService::_InitPreservedKey ()
{
	static const WCHAR	wszToggleImeDesc[]	= L"Toggle IME" ;
	static const WCHAR	wszImeOnKeyDesc[] = L"IME On" ;
	static const WCHAR	wszImeOffKeyDesc[] = L"IME Off" ;
    ITfKeystrokeMgr*	pKeystrokeMgr ;
	const TF_PRESERVEDKEY*	pKeys ;
	UINT				numberOfKeys ;
	HRESULT				hr ;

	if (m_pThreadMgr == NULL)
		return	FALSE ;
	if (m_pThreadMgr->QueryInterface (IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
		return	FALSE ;

	pKeys	= CImeConfig::pGetToggleImeKeys (_GetIMEConfig (), &numberOfKeys) ;
	while (numberOfKeys > 0) {
		hr	= pKeystrokeMgr->PreserveKey (m_tfClientId, c_guidSkkImePreservedKeyToggleIME, pKeys, wszToggleImeDesc, ARRAYSIZE(wszToggleImeDesc)-1) ;
		if (hr == TF_E_ALREADY_EXISTS)
			hr	= S_OK ;
		pKeys	++ ;
		numberOfKeys	-- ;
	}
    pKeystrokeMgr->Release () ;

	if (! _IsKeyboardOpen ()) {
		_RegisterImeOnKeys () ;
	} else {
		//_RegisterImeOffKeys () ;
	}
	return	(hr == S_OK) ;
}

/*	_UninitPreservedKey
 *
 *	o^ Hot Key 𖢓o^Ԃɖ߂B
 */
void
CSkkImeTextService::_UninitPreservedKey ()
{
    ITfKeystrokeMgr*	pKeystrokeMgr ;
	const TF_PRESERVEDKEY*	pKeys ;
	UINT				numberOfKeys ;

	if (m_pThreadMgr == NULL)
		return ;
	if (m_pThreadMgr->QueryInterface (IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
		return ;

	pKeys	= CImeConfig::pGetToggleImeKeys (_GetIMEConfig (), &numberOfKeys) ;
	while (numberOfKeys > 0) {
		pKeystrokeMgr->UnpreserveKey (c_guidSkkImePreservedKeyToggleIME, pKeys) ;
		pKeys	++ ;
		numberOfKeys	-- ;
	}
	pKeystrokeMgr->Release () ;

	_UnregisterImeOnKeys () ;
	_UnregisterImeOffKeys () ;
	return ;
}

BOOL
CSkkImeTextService::_RegisterImeOnKeys ()
{
	static const WCHAR	wszImeOnKeyDesc[] = L"IME On" ;
    ITfKeystrokeMgr*	pKeystrokeMgr ;
	const TF_PRESERVEDKEY*	pKeys ;
	UINT				numberOfKeys ;
	HRESULT				hr ;

	if (m_pThreadMgr == NULL)
		return	FALSE ;
	if (m_pThreadMgr->QueryInterface (IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
		return	FALSE ;

	pKeys	= CImeConfig::pGetImeOnKeys (_GetIMEConfig (), &numberOfKeys) ;
	while (numberOfKeys > 0) {
		hr	= pKeystrokeMgr->PreserveKey (m_tfClientId, c_guidSkkImePreservedKeyImeOn, pKeys, wszImeOnKeyDesc, ARRAYSIZE(wszImeOnKeyDesc)-1) ;
		if (hr == TF_E_ALREADY_EXISTS)
			hr	= S_OK ;
		pKeys	++ ;
		numberOfKeys	-- ;
	}
    pKeystrokeMgr->Release () ;
	return	(hr == S_OK) ;
}

void
CSkkImeTextService::_UnregisterImeOnKeys ()
{
    ITfKeystrokeMgr*	pKeystrokeMgr ;
	const TF_PRESERVEDKEY*	pKeys ;
	UINT				numberOfKeys ;

	if (m_pThreadMgr == NULL)
		return ;
	if (m_pThreadMgr->QueryInterface (IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
		return ;

	pKeys	= CImeConfig::pGetImeOnKeys (_GetIMEConfig (), &numberOfKeys) ;
	while (numberOfKeys > 0) {
		pKeystrokeMgr->UnpreserveKey (c_guidSkkImePreservedKeyImeOn, pKeys) ;
		pKeys	++ ;
		numberOfKeys	-- ;
	}
	pKeystrokeMgr->Release () ;
	return ;
}

BOOL
CSkkImeTextService::_RegisterImeOffKeys ()
{
	static const WCHAR	wszImeOnKeyDesc[] = L"IME Off" ;
    ITfKeystrokeMgr*	pKeystrokeMgr ;
	const TF_PRESERVEDKEY*	pKeys ;
	UINT				numberOfKeys ;
	HRESULT				hr ;

	if (m_pThreadMgr == NULL)
		return	FALSE ;
	if (m_pThreadMgr->QueryInterface (IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
		return	FALSE ;

	pKeys	= CImeConfig::pGetImeOffKeys (_GetIMEConfig (), &numberOfKeys) ;
	while (numberOfKeys > 0) {
		hr	= pKeystrokeMgr->PreserveKey (m_tfClientId, c_guidSkkImePreservedKeyImeOff, pKeys, wszImeOnKeyDesc, ARRAYSIZE(wszImeOnKeyDesc)-1) ;
		if (hr == TF_E_ALREADY_EXISTS)
			hr	= S_OK ;
		pKeys	++ ;
		numberOfKeys	-- ;
	}
    pKeystrokeMgr->Release () ;
	return	(hr == S_OK) ;
}

void
CSkkImeTextService::_UnregisterImeOffKeys ()
{
    ITfKeystrokeMgr*	pKeystrokeMgr ;
	const TF_PRESERVEDKEY*	pKeys ;
	UINT				numberOfKeys ;

	if (m_pThreadMgr == NULL)
		return ;
	if (m_pThreadMgr->QueryInterface (IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr) != S_OK)
		return ;

	pKeys	= CImeConfig::pGetImeOffKeys (_GetIMEConfig (), &numberOfKeys) ;
	while (numberOfKeys > 0) {
		pKeystrokeMgr->UnpreserveKey (c_guidSkkImePreservedKeyImeOff, pKeys) ;
		pKeys	++ ;
		numberOfKeys	-- ;
	}
	pKeystrokeMgr->Release () ;
	return ;
}

/*	OnSetFocus
 *
 *	̃T[rX keystroke device focus 𓾂͏ɃVXeɂ
 *	ĂяoB
 *	܂́AꂪAOnTestKeyDown Ă΂oƍlč\Ȃ
 *	낤B
 */
STDAPI
CSkkImeTextService::OnSetFocus (
	BOOL			fForeground)
{
    return	S_OK ;
	UNREFERENCED_PARAMETER (fForeground) ;
}

/*	OnTestKeyDown
 *
 *	̃T[rX^ꂽ potential keystroke ~邩ۂ
 *	q˂邽߂ɃVXeɂČĂяoB(A)
 *
 *	ŁAL[Xg[N~AƕԂ΁AOnKeyDown Ăяo
 *	邱ƂɂȂB
 */
STDAPI
CSkkImeTextService::OnTestKeyDown (
	ITfContext*		pContext,
	WPARAM			wParam,
	LPARAM			lParam,
	BOOL*			pfEaten)
{
	int		nEaten ;
	DWORD	dwKeyMask ;
	BOOL	bEaten ;

	DEBUGPRINTF ((TEXT ("CSkkImeTextService::OnTestKeyDown (w:0x%0x, l:0x%0x)\n"), (DWORD)wParam, (DWORD)lParam)) ;
	if (_IsKeyboardDisabled ()) {
		*pfEaten	= FALSE ;
		DEBUGPRINTF ((TEXT ("CSkkImeTextService::OnTestKeyDown (fEaten: %d)\n"), *pfEaten)) ;
		return	S_OK ;
	}

	/*	xkeymacs  foward  event  context bit  1 Ă悤ɎvB
	 *	 key  process Ɣ肷ƁAǂ PowerPoint Ȃǂ \C-x\C-s Ȃǂ
	 *	삪܂Ȃ炵BWord ŔoȂ̂́AWord  context bit 𔻕ʂĂ
	 *	̂낤cH (Wed Feb 15 20:28:29 2006)
	 */
	if (lParam & ((DWORD)1 << 29)) {
		*pfEaten	= FALSE ;
		return	S_OK ;
	}

	dwKeyMask	= 0 ;
	dwKeyMask	|= (GetKeyState (VK_LCONTROL) & 0x8000)?	KEYMASK_LCONTROL	: 0 ;
	dwKeyMask	|= (GetKeyState (VK_RCONTROL) & 0x8000)?	KEYMASK_RCONTROL	: 0 ;
	dwKeyMask	|= (GetKeyState (VK_LMENU)    & 0x8000)?	KEYMASK_LMENU		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_RMENU)    & 0x8000)?	KEYMASK_RMENU		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_LSHIFT)   & 0x8000)?	KEYMASK_LSHIFT		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_RSHIFT)   & 0x8000)?	KEYMASK_RSHIFT		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_SCROLL)   & 0x8000)?	KEYMASK_SCROLL		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_NUMLOCK)  & 0x8000)?	KEYMASK_NUMLOCK		: 0 ;

	nEaten		= m_pSkkIme->QueryProcessKey (wParam, lParam, dwKeyMask) ;
	bEaten		= (nEaten == SKKIME_PROCESS_KEY_TOGGLEIME) || (nEaten == SKKIME_PROCESS_KEY && _IsKeyboardOpen ()) ;
	*pfEaten	= bEaten ;
    return	S_OK ;
	UNREFERENCED_PARAMETER (pContext) ;
}

/*	OnKeyDown
 *
 *	Called by the system to offer this service a keystroke.  If *pfEaten == TRUE
 *	on exit, the application will not handle the keystroke.
 *
 *	VXeɂāÃT[rXɃL[Xg[N񋟂邽
 *	ɌĂяoBA*pfEaten == TRUE ŁA OnKeyDown 
 *	oAAvP[V͂̃L[Xg[N
 *	B(ۂɃL[Hׂ邩ǂ̔͒xłAƂ
 *	)
 */
STDAPI
CSkkImeTextService::OnKeyDown (
	ITfContext*		pContext,
	WPARAM			wParam,
	LPARAM			lParam,
	BOOL*			pfEaten)
{
//    CKeystrokeEditSession*	pEditSession ;
    HRESULT					hr ;
	DWORD					dwKeyMask ;
	int						nEaten ;

	hr			= S_FALSE ;
    *pfEaten	= FALSE ;

    if (!m_pSkkIme || _IsKeyboardDisabled ())
		goto	Exit ;
	if (m_pThreadMgr == NULL)
		goto	Exit ;

	/*	WordPad  OnTestKeyDown oRɒ OnKeyDown ɓ̂ŁA
	 *	OnTestKeyDown  KeyMask mۂłƍl邱Ƃ͂łȂB
	 *	Ă΂xɋ߂KvB
	 */
	dwKeyMask	= 0 ;
	dwKeyMask	|= (GetKeyState (VK_LCONTROL) & 0x8000)?	KEYMASK_LCONTROL	: 0 ;
	dwKeyMask	|= (GetKeyState (VK_RCONTROL) & 0x8000)?	KEYMASK_RCONTROL	: 0 ;
	dwKeyMask	|= (GetKeyState (VK_LMENU)    & 0x8000)?	KEYMASK_LMENU		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_RMENU)    & 0x8000)?	KEYMASK_RMENU		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_LSHIFT)   & 0x8000)?	KEYMASK_LSHIFT		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_RSHIFT)   & 0x8000)?	KEYMASK_RSHIFT		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_SCROLL)   & 0x8000)?	KEYMASK_SCROLL		: 0 ;
	dwKeyMask	|= (GetKeyState (VK_NUMLOCK)  & 0x8000)?	KEYMASK_NUMLOCK		: 0 ;

	nEaten	= m_pSkkIme->QueryProcessKey (wParam, lParam, dwKeyMask) ;
	if (nEaten == SKKIME_PROCESS_KEY_TOGGLEIME) {
		ITfKeystrokeMgr*	pKeystrokeMgr	= NULL ;

		if (FAILED (m_pThreadMgr->QueryInterface (IID_ITfKeystrokeMgr, (void **)&pKeystrokeMgr)))
			goto	Exit ;
		hr	= pKeystrokeMgr->SimulatePreservedKey (pContext, c_guidSkkImePreservedKeyToggleIME, pfEaten) ;
		pKeystrokeMgr->Release () ;
	} else if (_IsKeyboardOpen () && nEaten == SKKIME_PROCESS_KEY) {
		BOOL	fToggle, fCMode, fEaten ;

		/*	}邽߂ɁAOnEditSession  Compsition  Update OA
		 *	ClearComposite ėǂǂ̔f Composition  Update ʁXɏo悤
		 *	ύXB
		 */
		hr	= m_pSkkIme->OnEditSession (WM_KEYDOWN, wParam, lParam, dwKeyMask, &fToggle, &fCMode, &fEaten) ;
		if (FAILED (hr)) {
			fEaten	= TRUE ;
			fToggle	= FALSE ;
			fCMode	= FALSE ;
		}
		hr	= _SyncComposition (pContext, fToggle, fCMode) ;
		if (FAILED (hr))
			goto	Exit ;

		/*	̃R[h *pfEaten = FALSE ɂĕԂĂ key 
		 *	handle ĂȂꍇ̂߂ code c
		 *	ƂAhandle ȂłǁH > IE ȂǁB
		 *	̂ŁA*pfEaten = TRUE ɂĂAI keyevent
		 *	Ă݂B
		 *	bZ[W[vȂ悤ɒӁB
		 */
		if (! fEaten && CImeConfig::bTSFKeyDownEatenDoesNotWorkp (m_pConfig)) {
			INPUT	in ;
			WORD	woScanCode	= (WORD)(lParam >> 16) ;

#if defined (DEBUGLOGFILE_ENABLE)
			vDebugPrintfToFile (TEXT ("[%d] CSkkImeTextService -> SendInput (wVK:0x%0x, wScan:0x%0x)\r\n"), 
				GetTickCount (), wParam, lParam) ;
#endif
			memset (&in, 0, sizeof (in)) ;
			in.type				= INPUT_KEYBOARD ;
			in.ki.wVk			= wParam ;
			in.ki.wScan			= woScanCode & 0x007F ;
			in.ki.dwFlags		= KEYEVENTF_SCANCODE ;
			if ((woScanCode & 0xFF00) == 0xE000)
				in.ki.dwFlags	|= KEYEVENTF_EXTENDEDKEY ;
			in.ki.time			= GetTickCount () ;
			in.ki.dwExtraInfo	= NULL ;
			SendInput (1, &in, sizeof (in)) ;
			fEaten	= TRUE ;
		}
		hr	= fEaten? S_OK : S_FALSE ;
	}
Exit:
    if (hr == S_OK) 
        *pfEaten = TRUE ;

	DEBUGPRINTF ((TEXT ("CSkkImeTextService::OnKeyDown (Eaten:%d)\n"), *pfEaten)) ;
    return S_OK;
}

/*	OnTestKeyUp
 *
 *	̃T[rX potentiaon L[Xg[N~邩ǂ
 *	₢킹邽߂ɃVXeɂČĂяoB
 *
 *	 Eaten Ԃ΁A OnKeyUp Ăяo邱
 *	ɂȂBƂAImeProcess ̂悤 KeyUp HׂĂ͂
 *	ƂƂ͖BƂ́Aނ Up/Down 
 *	΂ɂĈȂ΂ȂȂH
 */
STDAPI
CSkkImeTextService::OnTestKeyUp (
	ITfContext*		pContext,
	WPARAM			wParam,
	LPARAM			lParam,
	BOOL*			pfEaten)
{
    *pfEaten	= FALSE ;
    return	S_OK ;
	UNREFERENCED_PARAMETER (pContext) ;
	UNREFERENCED_PARAMETER (wParam) ;
	UNREFERENCED_PARAMETER (lParam) ;
}

/* OnKeyUp
 *
 * Called by the system to offer this service a keystroke.  If *pfEaten == TRUE
 * on exit, the application will not handle the keystroke.
 *
 *	VXeɂāÃT[rXɃL[Xg[N^邽߂ɌĂяoB
 *	A*pfEaten == TRUE  exit Ȃ΁AAvP[V͂̃L[Xg
 *	[NȂB
 */
STDAPI
CSkkImeTextService::OnKeyUp (
	ITfContext*		pContext,
	WPARAM			wParam,
	LPARAM			lParam,
	BOOL*			pfEaten)
{
    *pfEaten	= FALSE ;
    return	S_OK ;
	UNREFERENCED_PARAMETER (pContext) ;
	UNREFERENCED_PARAMETER (wParam) ;
	UNREFERENCED_PARAMETER (lParam) ;
}

/*	OnPreservedKey
 *
 *	Called when a hotkey (registered by us, or by the system) is typed.
 *	hotkey  type ꂽɌĂяoB(Ȃق)
 */
STDAPI
CSkkImeTextService::OnPreservedKey (
	ITfContext*		pContext,
	REFGUID			rguid,
	BOOL*			pfEaten)
{
	if (IsEqualGUID (rguid, c_guidSkkImePreservedKeyToggleIME) || 
		(IsEqualGUID (rguid, c_guidSkkImePreservedKeyImeOn) && !_IsKeyboardOpen()) ||
		(IsEqualGUID (rguid, c_guidSkkImePreservedKeyImeOff) && _IsKeyboardOpen())) {
		HRESULT	hrEaten	= S_FALSE ;

		_ToggleIME (pContext, &hrEaten) ;
		if (hrEaten == S_OK) {
			_UpdateLangBarItem (c_guidConversionModeItemButton) ;
		}
		*pfEaten	= (hrEaten == S_OK) ;
	} else {
		/*	FALSEhandleȂ͂܂@\Ȃ悤(2010/01/30)
		 */
		*pfEaten	= FALSE ;
	}
    return	S_OK ;
}


